package com.tmax.openframe.variable.group;

import ch.obermuhlner.math.big.BigDecimalMath;
import java.math.*;
import java.text.DecimalFormat;
import java.util.*;
import java.util.function.BiFunction;
import java.util.stream.*;
import lombok.*;
import org.apache.commons.lang3.StringUtils;

/** 
 * <p>This source code was generated by COBOL to JAVA migrator</p>
 */
public @AllArgsConstructor @NoArgsConstructor @Builder(builderClassName = "builder") class OIVPBROS_OIVPM02I {
    public @Getter @Builder.Default String FILLER1 = StringUtils
            .repeat(' ', 12);
    public @Getter @Setter int DATEL;
    public @Getter @Builder.Default String DATEF = StringUtils.repeat(' ', 1);

    public String getDATEA() {
        return DATEF;
    }

    public void setDATEA(String var) {
        DATEF = var;
    }

    public @Getter @Builder.Default String DATEI = StringUtils.repeat(' ', 8);
    public @Getter @Setter int TERML;
    public @Getter @Builder.Default String TERMF = StringUtils.repeat(' ', 1);

    public String getTERMA() {
        return TERMF;
    }

    public void setTERMA(String var) {
        TERMF = var;
    }

    public @Getter @Builder.Default String TERMI = StringUtils.repeat(' ', 4);
    public @Getter @Setter int TIMEL;
    public @Getter @Builder.Default String TIMEF = StringUtils.repeat(' ', 1);

    public String getTIMEA() {
        return TIMEF;
    }

    public void setTIMEA(String var) {
        TIMEF = var;
    }

    public @Getter @Builder.Default String TIMEI = StringUtils.repeat(' ', 8);
    public @Getter @Setter int IDEN1L;
    public @Getter @Builder.Default String IDEN1F = StringUtils.repeat(' ', 1);

    public String getIDEN1A() {
        return IDEN1F;
    }

    public void setIDEN1A(String var) {
        IDEN1F = var;
    }

    public @Getter @Builder.Default String IDEN1I = StringUtils.repeat(' ', 8);
    public @Getter @Setter int NAME1L;
    public @Getter @Builder.Default String NAME1F = StringUtils.repeat(' ', 1);

    public String getNAME1A() {
        return NAME1F;
    }

    public void setNAME1A(String var) {
        NAME1F = var;
    }

    public @Getter @Builder.Default String NAME1I = StringUtils.repeat(' ', 10);
    public @Getter @Setter int DEPT1L;
    public @Getter @Builder.Default String DEPT1F = StringUtils.repeat(' ', 1);

    public String getDEPT1A() {
        return DEPT1F;
    }

    public void setDEPT1A(String var) {
        DEPT1F = var;
    }

    public @Getter @Builder.Default String DEPT1I = StringUtils.repeat(' ', 15);
    public @Getter @Setter int PHON1L;
    public @Getter @Builder.Default String PHON1F = StringUtils.repeat(' ', 1);

    public String getPHON1A() {
        return PHON1F;
    }

    public void setPHON1A(String var) {
        PHON1F = var;
    }

    public @Getter @Builder.Default String PHON1I = StringUtils.repeat(' ', 15);
    public @Getter @Setter int IDEN2L;
    public @Getter @Builder.Default String IDEN2F = StringUtils.repeat(' ', 1);

    public String getIDEN2A() {
        return IDEN2F;
    }

    public void setIDEN2A(String var) {
        IDEN2F = var;
    }

    public @Getter @Builder.Default String IDEN2I = StringUtils.repeat(' ', 8);
    public @Getter @Setter int NAME2L;
    public @Getter @Builder.Default String NAME2F = StringUtils.repeat(' ', 1);

    public String getNAME2A() {
        return NAME2F;
    }

    public void setNAME2A(String var) {
        NAME2F = var;
    }

    public @Getter @Builder.Default String NAME2I = StringUtils.repeat(' ', 10);
    public @Getter @Setter int DEPT2L;
    public @Getter @Builder.Default String DEPT2F = StringUtils.repeat(' ', 1);

    public String getDEPT2A() {
        return DEPT2F;
    }

    public void setDEPT2A(String var) {
        DEPT2F = var;
    }

    public @Getter @Builder.Default String DEPT2I = StringUtils.repeat(' ', 15);
    public @Getter @Setter int PHON2L;
    public @Getter @Builder.Default String PHON2F = StringUtils.repeat(' ', 1);

    public String getPHON2A() {
        return PHON2F;
    }

    public void setPHON2A(String var) {
        PHON2F = var;
    }

    public @Getter @Builder.Default String PHON2I = StringUtils.repeat(' ', 15);
    public @Getter @Setter int IDEN3L;
    public @Getter @Builder.Default String IDEN3F = StringUtils.repeat(' ', 1);

    public String getIDEN3A() {
        return IDEN3F;
    }

    public void setIDEN3A(String var) {
        IDEN3F = var;
    }

    public @Getter @Builder.Default String IDEN3I = StringUtils.repeat(' ', 8);
    public @Getter @Setter int NAME3L;
    public @Getter @Builder.Default String NAME3F = StringUtils.repeat(' ', 1);

    public String getNAME3A() {
        return NAME3F;
    }

    public void setNAME3A(String var) {
        NAME3F = var;
    }

    public @Getter @Builder.Default String NAME3I = StringUtils.repeat(' ', 10);
    public @Getter @Setter int DEPT3L;
    public @Getter @Builder.Default String DEPT3F = StringUtils.repeat(' ', 1);

    public String getDEPT3A() {
        return DEPT3F;
    }

    public void setDEPT3A(String var) {
        DEPT3F = var;
    }

    public @Getter @Builder.Default String DEPT3I = StringUtils.repeat(' ', 15);
    public @Getter @Setter int PHON3L;
    public @Getter @Builder.Default String PHON3F = StringUtils.repeat(' ', 1);

    public String getPHON3A() {
        return PHON3F;
    }

    public void setPHON3A(String var) {
        PHON3F = var;
    }

    public @Getter @Builder.Default String PHON3I = StringUtils.repeat(' ', 15);
    public @Getter @Setter int IDEN4L;
    public @Getter @Builder.Default String IDEN4F = StringUtils.repeat(' ', 1);

    public String getIDEN4A() {
        return IDEN4F;
    }

    public void setIDEN4A(String var) {
        IDEN4F = var;
    }

    public @Getter @Builder.Default String IDEN4I = StringUtils.repeat(' ', 8);
    public @Getter @Setter int NAME4L;
    public @Getter @Builder.Default String NAME4F = StringUtils.repeat(' ', 1);

    public String getNAME4A() {
        return NAME4F;
    }

    public void setNAME4A(String var) {
        NAME4F = var;
    }

    public @Getter @Builder.Default String NAME4I = StringUtils.repeat(' ', 10);
    public @Getter @Setter int DEPT4L;
    public @Getter @Builder.Default String DEPT4F = StringUtils.repeat(' ', 1);

    public String getDEPT4A() {
        return DEPT4F;
    }

    public void setDEPT4A(String var) {
        DEPT4F = var;
    }

    public @Getter @Builder.Default String DEPT4I = StringUtils.repeat(' ', 15);
    public @Getter @Setter int PHON4L;
    public @Getter @Builder.Default String PHON4F = StringUtils.repeat(' ', 1);

    public String getPHON4A() {
        return PHON4F;
    }

    public void setPHON4A(String var) {
        PHON4F = var;
    }

    public @Getter @Builder.Default String PHON4I = StringUtils.repeat(' ', 15);
    public @Getter @Setter int IDEN5L;
    public @Getter @Builder.Default String IDEN5F = StringUtils.repeat(' ', 1);

    public String getIDEN5A() {
        return IDEN5F;
    }

    public void setIDEN5A(String var) {
        IDEN5F = var;
    }

    public @Getter @Builder.Default String IDEN5I = StringUtils.repeat(' ', 8);
    public @Getter @Setter int NAME5L;
    public @Getter @Builder.Default String NAME5F = StringUtils.repeat(' ', 1);

    public String getNAME5A() {
        return NAME5F;
    }

    public void setNAME5A(String var) {
        NAME5F = var;
    }

    public @Getter @Builder.Default String NAME5I = StringUtils.repeat(' ', 10);
    public @Getter @Setter int DEPT5L;
    public @Getter @Builder.Default String DEPT5F = StringUtils.repeat(' ', 1);

    public String getDEPT5A() {
        return DEPT5F;
    }

    public void setDEPT5A(String var) {
        DEPT5F = var;
    }

    public @Getter @Builder.Default String DEPT5I = StringUtils.repeat(' ', 15);
    public @Getter @Setter int PHON5L;
    public @Getter @Builder.Default String PHON5F = StringUtils.repeat(' ', 1);

    public String getPHON5A() {
        return PHON5F;
    }

    public void setPHON5A(String var) {
        PHON5F = var;
    }

    public @Getter @Builder.Default String PHON5I = StringUtils.repeat(' ', 15);
    public @Getter @Setter int BIDXL;
    public @Getter @Builder.Default String BIDXF = StringUtils.repeat(' ', 1);

    public String getBIDXA() {
        return BIDXF;
    }

    public void setBIDXA(String var) {
        BIDXF = var;
    }

    public @Getter @Builder.Default String BIDXI = StringUtils.repeat(' ', 8);
    public @Getter @Setter int FIDXL;
    public @Getter @Builder.Default String FIDXF = StringUtils.repeat(' ', 1);

    public String getFIDXA() {
        return FIDXF;
    }

    public void setFIDXA(String var) {
        FIDXF = var;
    }

    public @Getter @Builder.Default String FIDXI = StringUtils.repeat(' ', 8);
    public @Getter @Setter int MSGL;
    public @Getter @Builder.Default String MSGF = StringUtils.repeat(' ', 1);

    public String getMSGA() {
        return MSGF;
    }

    public void setMSGA(String var) {
        MSGF = var;
    }

    public @Getter @Builder.Default String MSGI = StringUtils.repeat(' ', 76);
    private final static BiFunction<Long, String, String> intFormatWithSign = (
            value, format) -> {
        DecimalFormat nf = new DecimalFormat();
        nf.applyPattern("+" + format + ";-" + format);
        return nf.format(value);
    };

    public void setFILLER1(String source) {
        FILLER1 = StringUtils.truncate(StringUtils.rightPad(source, 12), 12);
    }

    public String getStringDATEL() {
        return intFormatWithSign.apply((long) DATEL, "0000");
    }

    public void setDATEF(String source) {
        DATEF = StringUtils.truncate(StringUtils.rightPad(source, 1), 1);
    }

    public void setDATEI(String source) {
        DATEI = StringUtils.truncate(StringUtils.rightPad(source, 8), 8);
    }

    public String getStringTERML() {
        return intFormatWithSign.apply((long) TERML, "0000");
    }

    public void setTERMF(String source) {
        TERMF = StringUtils.truncate(StringUtils.rightPad(source, 1), 1);
    }

    public void setTERMI(String source) {
        TERMI = StringUtils.truncate(StringUtils.rightPad(source, 4), 4);
    }

    public String getStringTIMEL() {
        return intFormatWithSign.apply((long) TIMEL, "0000");
    }

    public void setTIMEF(String source) {
        TIMEF = StringUtils.truncate(StringUtils.rightPad(source, 1), 1);
    }

    public void setTIMEI(String source) {
        TIMEI = StringUtils.truncate(StringUtils.rightPad(source, 8), 8);
    }

    public String getStringIDEN1L() {
        return intFormatWithSign.apply((long) IDEN1L, "0000");
    }

    public void setIDEN1F(String source) {
        IDEN1F = StringUtils.truncate(StringUtils.rightPad(source, 1), 1);
    }

    public void setIDEN1I(String source) {
        IDEN1I = StringUtils.truncate(StringUtils.rightPad(source, 8), 8);
    }

    public String getStringNAME1L() {
        return intFormatWithSign.apply((long) NAME1L, "0000");
    }

    public void setNAME1F(String source) {
        NAME1F = StringUtils.truncate(StringUtils.rightPad(source, 1), 1);
    }

    public void setNAME1I(String source) {
        NAME1I = StringUtils.truncate(StringUtils.rightPad(source, 10), 10);
    }

    public String getStringDEPT1L() {
        return intFormatWithSign.apply((long) DEPT1L, "0000");
    }

    public void setDEPT1F(String source) {
        DEPT1F = StringUtils.truncate(StringUtils.rightPad(source, 1), 1);
    }

    public void setDEPT1I(String source) {
        DEPT1I = StringUtils.truncate(StringUtils.rightPad(source, 15), 15);
    }

    public String getStringPHON1L() {
        return intFormatWithSign.apply((long) PHON1L, "0000");
    }

    public void setPHON1F(String source) {
        PHON1F = StringUtils.truncate(StringUtils.rightPad(source, 1), 1);
    }

    public void setPHON1I(String source) {
        PHON1I = StringUtils.truncate(StringUtils.rightPad(source, 15), 15);
    }

    public String getStringIDEN2L() {
        return intFormatWithSign.apply((long) IDEN2L, "0000");
    }

    public void setIDEN2F(String source) {
        IDEN2F = StringUtils.truncate(StringUtils.rightPad(source, 1), 1);
    }

    public void setIDEN2I(String source) {
        IDEN2I = StringUtils.truncate(StringUtils.rightPad(source, 8), 8);
    }

    public String getStringNAME2L() {
        return intFormatWithSign.apply((long) NAME2L, "0000");
    }

    public void setNAME2F(String source) {
        NAME2F = StringUtils.truncate(StringUtils.rightPad(source, 1), 1);
    }

    public void setNAME2I(String source) {
        NAME2I = StringUtils.truncate(StringUtils.rightPad(source, 10), 10);
    }

    public String getStringDEPT2L() {
        return intFormatWithSign.apply((long) DEPT2L, "0000");
    }

    public void setDEPT2F(String source) {
        DEPT2F = StringUtils.truncate(StringUtils.rightPad(source, 1), 1);
    }

    public void setDEPT2I(String source) {
        DEPT2I = StringUtils.truncate(StringUtils.rightPad(source, 15), 15);
    }

    public String getStringPHON2L() {
        return intFormatWithSign.apply((long) PHON2L, "0000");
    }

    public void setPHON2F(String source) {
        PHON2F = StringUtils.truncate(StringUtils.rightPad(source, 1), 1);
    }

    public void setPHON2I(String source) {
        PHON2I = StringUtils.truncate(StringUtils.rightPad(source, 15), 15);
    }

    public String getStringIDEN3L() {
        return intFormatWithSign.apply((long) IDEN3L, "0000");
    }

    public void setIDEN3F(String source) {
        IDEN3F = StringUtils.truncate(StringUtils.rightPad(source, 1), 1);
    }

    public void setIDEN3I(String source) {
        IDEN3I = StringUtils.truncate(StringUtils.rightPad(source, 8), 8);
    }

    public String getStringNAME3L() {
        return intFormatWithSign.apply((long) NAME3L, "0000");
    }

    public void setNAME3F(String source) {
        NAME3F = StringUtils.truncate(StringUtils.rightPad(source, 1), 1);
    }

    public void setNAME3I(String source) {
        NAME3I = StringUtils.truncate(StringUtils.rightPad(source, 10), 10);
    }

    public String getStringDEPT3L() {
        return intFormatWithSign.apply((long) DEPT3L, "0000");
    }

    public void setDEPT3F(String source) {
        DEPT3F = StringUtils.truncate(StringUtils.rightPad(source, 1), 1);
    }

    public void setDEPT3I(String source) {
        DEPT3I = StringUtils.truncate(StringUtils.rightPad(source, 15), 15);
    }

    public String getStringPHON3L() {
        return intFormatWithSign.apply((long) PHON3L, "0000");
    }

    public void setPHON3F(String source) {
        PHON3F = StringUtils.truncate(StringUtils.rightPad(source, 1), 1);
    }

    public void setPHON3I(String source) {
        PHON3I = StringUtils.truncate(StringUtils.rightPad(source, 15), 15);
    }

    public String getStringIDEN4L() {
        return intFormatWithSign.apply((long) IDEN4L, "0000");
    }

    public void setIDEN4F(String source) {
        IDEN4F = StringUtils.truncate(StringUtils.rightPad(source, 1), 1);
    }

    public void setIDEN4I(String source) {
        IDEN4I = StringUtils.truncate(StringUtils.rightPad(source, 8), 8);
    }

    public String getStringNAME4L() {
        return intFormatWithSign.apply((long) NAME4L, "0000");
    }

    public void setNAME4F(String source) {
        NAME4F = StringUtils.truncate(StringUtils.rightPad(source, 1), 1);
    }

    public void setNAME4I(String source) {
        NAME4I = StringUtils.truncate(StringUtils.rightPad(source, 10), 10);
    }

    public String getStringDEPT4L() {
        return intFormatWithSign.apply((long) DEPT4L, "0000");
    }

    public void setDEPT4F(String source) {
        DEPT4F = StringUtils.truncate(StringUtils.rightPad(source, 1), 1);
    }

    public void setDEPT4I(String source) {
        DEPT4I = StringUtils.truncate(StringUtils.rightPad(source, 15), 15);
    }

    public String getStringPHON4L() {
        return intFormatWithSign.apply((long) PHON4L, "0000");
    }

    public void setPHON4F(String source) {
        PHON4F = StringUtils.truncate(StringUtils.rightPad(source, 1), 1);
    }

    public void setPHON4I(String source) {
        PHON4I = StringUtils.truncate(StringUtils.rightPad(source, 15), 15);
    }

    public String getStringIDEN5L() {
        return intFormatWithSign.apply((long) IDEN5L, "0000");
    }

    public void setIDEN5F(String source) {
        IDEN5F = StringUtils.truncate(StringUtils.rightPad(source, 1), 1);
    }

    public void setIDEN5I(String source) {
        IDEN5I = StringUtils.truncate(StringUtils.rightPad(source, 8), 8);
    }

    public String getStringNAME5L() {
        return intFormatWithSign.apply((long) NAME5L, "0000");
    }

    public void setNAME5F(String source) {
        NAME5F = StringUtils.truncate(StringUtils.rightPad(source, 1), 1);
    }

    public void setNAME5I(String source) {
        NAME5I = StringUtils.truncate(StringUtils.rightPad(source, 10), 10);
    }

    public String getStringDEPT5L() {
        return intFormatWithSign.apply((long) DEPT5L, "0000");
    }

    public void setDEPT5F(String source) {
        DEPT5F = StringUtils.truncate(StringUtils.rightPad(source, 1), 1);
    }

    public void setDEPT5I(String source) {
        DEPT5I = StringUtils.truncate(StringUtils.rightPad(source, 15), 15);
    }

    public String getStringPHON5L() {
        return intFormatWithSign.apply((long) PHON5L, "0000");
    }

    public void setPHON5F(String source) {
        PHON5F = StringUtils.truncate(StringUtils.rightPad(source, 1), 1);
    }

    public void setPHON5I(String source) {
        PHON5I = StringUtils.truncate(StringUtils.rightPad(source, 15), 15);
    }

    public String getStringBIDXL() {
        return intFormatWithSign.apply((long) BIDXL, "0000");
    }

    public void setBIDXF(String source) {
        BIDXF = StringUtils.truncate(StringUtils.rightPad(source, 1), 1);
    }

    public void setBIDXI(String source) {
        BIDXI = StringUtils.truncate(StringUtils.rightPad(source, 8), 8);
    }

    public String getStringFIDXL() {
        return intFormatWithSign.apply((long) FIDXL, "0000");
    }

    public void setFIDXF(String source) {
        FIDXF = StringUtils.truncate(StringUtils.rightPad(source, 1), 1);
    }

    public void setFIDXI(String source) {
        FIDXI = StringUtils.truncate(StringUtils.rightPad(source, 8), 8);
    }

    public String getStringMSGL() {
        return intFormatWithSign.apply((long) MSGL, "0000");
    }

    public void setMSGF(String source) {
        MSGF = StringUtils.truncate(StringUtils.rightPad(source, 1), 1);
    }

    public void setMSGI(String source) {
        MSGI = StringUtils.truncate(StringUtils.rightPad(source, 76), 76);
    }

    public static OIVPBROS_OIVPM02I createDefaultValueInstance() {
        return new OIVPBROS_OIVPM02I.builder().build();
    }

    @Override
    public String toString() {
        return FILLER1 + String.valueOf(getDATEL()) + getDATEF() + getDATEI()
                + String.valueOf(getTERML()) + getTERMF() + getTERMI()
                + String.valueOf(getTIMEL()) + getTIMEF() + getTIMEI()
                + String.valueOf(getIDEN1L()) + getIDEN1F() + getIDEN1I()
                + String.valueOf(getNAME1L()) + getNAME1F() + getNAME1I()
                + String.valueOf(getDEPT1L()) + getDEPT1F() + getDEPT1I()
                + String.valueOf(getPHON1L()) + getPHON1F() + getPHON1I()
                + String.valueOf(getIDEN2L()) + getIDEN2F() + getIDEN2I()
                + String.valueOf(getNAME2L()) + getNAME2F() + getNAME2I()
                + String.valueOf(getDEPT2L()) + getDEPT2F() + getDEPT2I()
                + String.valueOf(getPHON2L()) + getPHON2F() + getPHON2I()
                + String.valueOf(getIDEN3L()) + getIDEN3F() + getIDEN3I()
                + String.valueOf(getNAME3L()) + getNAME3F() + getNAME3I()
                + String.valueOf(getDEPT3L()) + getDEPT3F() + getDEPT3I()
                + String.valueOf(getPHON3L()) + getPHON3F() + getPHON3I()
                + String.valueOf(getIDEN4L()) + getIDEN4F() + getIDEN4I()
                + String.valueOf(getNAME4L()) + getNAME4F() + getNAME4I()
                + String.valueOf(getDEPT4L()) + getDEPT4F() + getDEPT4I()
                + String.valueOf(getPHON4L()) + getPHON4F() + getPHON4I()
                + String.valueOf(getIDEN5L()) + getIDEN5F() + getIDEN5I()
                + String.valueOf(getNAME5L()) + getNAME5F() + getNAME5I()
                + String.valueOf(getDEPT5L()) + getDEPT5F() + getDEPT5I()
                + String.valueOf(getPHON5L()) + getPHON5F() + getPHON5I()
                + String.valueOf(getBIDXL()) + getBIDXF() + getBIDXI()
                + String.valueOf(getFIDXL()) + getFIDXF() + getFIDXI()
                + String.valueOf(getMSGL()) + getMSGF() + getMSGI();
    }
}
